]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.gitconfig: Add alias `stashes`
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    has_completion() { return 0; }
75    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
76       if [ "$SHELL" = /bin/bash ]; then
77          if [ -d /usr/share/bash-completion ]; then
78             . /usr/share/bash-completion/bash_completion
79             has_completion() { [ -r /usr/share/bash-completion/completions/$1 ]; }
80          elif [ -f /etc/bash_completion ]; then
81             . /etc/bash_completion
82             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
83          elif [ -d /etc/bash_completion.d ]; then
84             for _compf in /etc/bash_completion.d/*; do
85                . $_compf
86             done
87             has_completion() { [ -r /etc/bash_completion.d/$1 ]; }
88          fi
89       elif [ "$SHELL" = /usr/local/bin/bash ]; then
90          if [ -d /usr/local/etc/bash_completion.d ]; then
91             for _compf in /usr/local/etc/bash_completion.d/*; do
92                . $_compf
93             done
94             has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
95          fi
96       else
97          echo "Unknown OS type, cannot source bash_completion" >&2
98       fi
99    fi
100
101    for cmd in builtin cgmem_nice command dbus-launch exec \
102       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
103       time whence whereis which xargs; do
104          ! has_completion $cmd && complete -o default -A command $cmd
105    done
106
107    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
108       telnet t tt \
109       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
110       whois wget wget-m wget-wrapper ww; do
111          ! has_completion $cmd && complete -A hostname $cmd
112    done
113
114    for cmd in distribute ftp lftp r rsync \
115       s scp ssh smbclient tcpdump tshark wireshark; do
116          ! has_completion $cmd && complete -o default -A hostname $cmd;
117    done
118
119    delegate_completion() {
120       local prog programs
121       prog=$1
122       if has_completion $prog; then
123          shift
124          programs="$@"
125          eval "_${prog}_completion_loader() {
126             _completion_loader $prog
127             complete -F _$prog $programs
128             unset _${prog}_completion_loader
129             return 124
130          }"
131          complete -F _${prog}_completion_loader $programs
132       fi
133    }
134
135    delegate_completion make m
136    delegate_completion ping p
137    delegate_completion rsync r
138    delegate_completion ssh s
139    delegate_completion wget wget-m wget-wrapper ww
140
141    unset has_completion delegate_completion
142
143    complete -A job bg fg j jobs wait
144    complete -A variable -A function unset
145
146    if [ -d "$HOME/lib/config" ]; then
147       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
148    fi
149    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
150
151    #if type -p pip >/dev/null 2>&1; then
152    #   eval "`pip completion --bash`"
153    #   rm -rf /tmp/pip_build_"$USER"
154    #fi
155
156    #if which pyenv >/dev/null 2>&1; then
157    #   eval "`pyenv init -`"
158    #   eval "`pyenv virtualenv-init -`"
159    #fi
160
161    source virtualenvwrapper_lazy.sh 2>/dev/null
162
163    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
164       . "$VIRTUAL_ENV/bin/activate"
165    fi
166
167 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
168    back() { cd - "$@"; }
169    j() { jobs; }
170 fi
171
172
173 # clear screen and history, logout
174 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
175
176
177 if test -x /usr/bin/git >/dev/null 2>&1; then
178    # chdir to a directory
179    cdgitpath() {
180       if [ -z "$1" -o -n "$2" ]; then
181          echo "Usage: cdgitpath path_key" >&2
182          return 1
183       else
184          path_key="$1"
185       fi
186
187       if [ -z "$path_key" ]; then
188          echo "Usage: cdgitpath path_key" >&2
189          return 1
190       fi
191
192       cd "`git config --get --path $path_key`"
193    }
194
195    # chdir to a remote's directory (if the remote is on the local FS)
196    cdremote() {
197       if [ -z "$1" ]; then
198          branch="`git rev-parse --abbrev-ref HEAD`"
199          remote="`git config --get branch.$branch.remote`"
200       elif [ -n "$2" ]; then
201          echo "Usage: cdremote [remote_name]" >&2
202          return 1
203       else
204          remote="$1"
205       fi
206
207       if [ -z "$remote" ]; then
208          echo "Cannot find remote for branch $branch" >&2
209          echo "Usage: cdremote [remote_name]" >&2
210          return 1
211       fi
212
213       cdgitpath remote.$remote.url
214    }
215
216    if test -n "$BASH_VERSION"; then
217       # completion for aliases in global .gitconfig
218
219       # fixup rbi rbia rbiap rbip - do refs name completion
220       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
221       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
222       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
223       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
224       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
225       #
226       # push-to-all-remotes - do branch name completion
227       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
228
229       _cdgitpath_completion_loader() {
230          _completion_loader git
231          complete -F _cdgitpath_complete cdgitpath git-open
232          unset _cdgitpath_completion_loader
233          return 124
234       }
235
236       _cdgitpath_complete() {
237          local cword="${COMP_CWORD}" cur="${COMP_WORDS[COMP_CWORD]}";
238          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
239       }
240
241       _git_open() {
242          _cdgitpath_complete
243       }
244
245       complete -F _cdgitpath_completion_loader cdgitpath git-open
246
247       # list remotes with URLs matching a regexp
248       _list_remotes() {
249          if [ -z "$1" -o -n "$2" ]; then
250             echo "Usage: _list_remotes remote_regexp" >&2
251             return 1
252          fi
253          GIT_REMOTES=""
254          local remote
255          for remote in `git remote`; do
256             if git config --get remote.$remote.url | grep -q "$1"; then
257                GIT_REMOTES="$GIT_REMOTES $remote"
258             fi
259          done
260       }
261
262       # completion for cdremote and git-open-remote - list remotes with a pattern
263       _list_remotes_completion() {
264          local cur="${COMP_WORDS[COMP_CWORD]}";
265          _list_remotes "$1"
266          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
267          unset GIT_REMOTES
268       }
269
270       # completion for cdremote - list remotes with directories as URLs
271       _cdremote_complete() {
272          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
273          if [ ${#COMPREPLY[*]} -eq 0 ]; then
274             _list_remotes_completion .
275          fi
276       }
277
278       complete -F _cdremote_complete cdremote
279
280       # completion for git-open-remote - list remotes with http(s) URLs
281       _git_open_remote() {
282          _list_remotes_completion '^http\(s\)\?://'
283          if [ ${#COMPREPLY[*]} -eq 0 ]; then
284             _list_remotes_completion .
285          fi
286       }
287
288       complete -F _git_open_remote git-open-remote
289    fi
290 fi
291
292
293 include() {
294    cfg="$1"
295    if [ -f "./$cfg" -a -r "./$cfg" ]; then
296       echo "Reading config file \`$cfg'" 1>&2
297       . "./$cfg"
298    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
299       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
300       . "$HOME/lib/config/$cfg"
301    else
302       echo "Cannot find config file \`$cfg'" 1>&2
303    fi
304 }
305
306
307 mc() {
308    if test -n "$BASH_VERSION"; then
309       MC_SAVE_OPS1="$OPS1"
310       OPS1="\u@\h "
311    fi
312
313    if [ -n "$SLOWTERM" ]; then
314       MC_SLOW="--slow"
315    fi
316
317    case "$TERM" in
318       screen*) # screen, screen.rxvt
319          if [ "$TERM" = screen.rxvt ]; then
320             MC_SAVE_TERM="$TERM"
321             TERM=rxvt
322          fi
323          MC_XTERM="-x"
324       ;;
325    esac
326
327    #TMPDIR="$HOME"/tmp
328    #export TMPDIR
329
330    MC_FOUND=NO
331
332    for wrapper in \
333          /usr/local/share/mc/bin/mc-wrapper.sh \
334          /usr/local/libexec/mc/mc-wrapper.sh \
335          /usr/share/mc/bin/mc-wrapper.sh; do
336       if [ -r $wrapper ]; then
337          . $wrapper $MC_SLOW $MC_XTERM "$@"
338          rc=$?
339          MC_FOUND=YES
340          break
341       fi
342    done
343
344    if [ $MC_FOUND = NO ]; then
345       for mc in /usr/local/bin/mc /usr/bin/mc; do
346          if [ -x $mc ]; then
347             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
348             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
349                MC_TMP_DIR="${TMPDIR-/tmp}"
350             fi
351             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
352             mc_type="`mc_type.py $mc`"
353             if [ "$mc_type" = old ]; then
354                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
355             elif [ "$mc_type" = new ]; then
356                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
357             else
358                continue
359             fi
360             rc=$?
361             MC_FOUND=YES
362             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
363             break
364          fi
365       done
366    fi
367
368    if [ $MC_FOUND = NO ]; then
369       echo "Cannot find mc-wrapper.sh or mc" >&2
370       rc=1
371    fi
372
373    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
374    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
375    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
376          MC_SLOW MC_TMP_DIR MC_XTERM
377
378    return $rc
379 }
380
381
382 mkcd() {
383    if [ $# -ne 1 ]; then
384       echo "Usage: mkcd directory_name" >&2
385    elif [ -d "$1" ]; then
386       cd "$1"
387    elif [ -e "$1" ]; then
388       echo "Error: $1 is a file" >&2
389    else
390       mkdir -p "$1" && cd "$1"
391    fi
392 }
393
394
395 if which tmux >/dev/null 2>&1; then
396    tmux() {
397       case "$TERM" in
398          rxvt)
399             TERM=rxvt-unicode command tmux "$@"
400          ;;
401
402          *)
403             command tmux "$@"
404          ;;
405       esac
406    }
407 fi
408
409
410 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
411    X() { startx >> .Xserver.log 2>&1; cyr; rm -f .Xauthority; }
412 fi
413
414 x() { exit; }